/* UQLX */

#include "QL68000.h"

#ifdef SOUND
#include "driver.h"
#include "QL_sound.h"


/* Sure, I can add a TRAP #3 to change this if */
/* you give me access to the IOCTL. And IO.PAN */
/* could work, too?! But I think the frequency */
/* control from inside QDOS would be most useful, */
/* and I'm tempted to suggest overloading the POSAB */
/* and POSRE trap #3 keys for the SOUND device so */
/* people can set (and, crucially given that it is */
/* quantised by the driver) *read* the rate with */
/* SET_POSITION and POSITION (or FPOS, etc) calls */
/* already in SuperBASIC toolkits. */

//POSAB: set/get sample rate
//FLUSH: sync (start playing)

// open '@soundrx_freq_fmt'
//      r,x(#channels),freq,fmt optional
//      defaults: w,mono,8000,u8
// D3 key ignored
//   fmt: u8,s8,au,u16be,s16be


open_arg sound_par[4];

int sound_init(int idx, void *d){printf("init test driver\n");}

#define o_letter(x) (x>31?x:' ')
struct sound_data{
  int fd;
};

int sound_open(int ix,void **priv)
{
  struct sound_data *priv;
  char *p;
  int fd,flags,fmt;
  printf("sound channel opened:\n");
  printf("\t parsed values: %c,%c,%d\n",o_letter(sound_par[0].i),o_letter(sound_par[1].i),sound_par[2].i);

  flags = (sound_par[0].i>0?O_RDWR: O_WRONLY);
  fd=open("/dev/dsp",flags);
  setfreq(priv,sound_par[1].i);

  return 0;
}

int sound_test(int id,char *name)
{
  //  printf ("sound: %s\n",name+2);
  return decode_name(name,Drivers[id].namep,&sound_par);
}


int sound_pend(struct sound_data *p)
{
  if (check_pend(p->fd,SLC_READ)) return 0;
  else return QERR_NC;
}

int sound_read(struct sound_data  *p, void *buf, int pno)
{
  int res;

  res=read(p->fd,buf,pno);

  if (res<0) res=qmaperr();
  return res;
}

static int sound_write(struct sound_data  *p, void *buf, int pno)
{
  int res;

  res=write(p->fd,buf,pno);

  if (res<0) res=qmaperr();
  return res;
}



void sound_io(int ix, void *priv)
{
  switch(op)
    {
      
    default:
      io_handle(sound_read, sound_write, sound_pend, priv);
      return;
    }
}

void sound_close(int ix, void *priv){}
#endif
